//==============================================================================
// File:    data-summarizer.cpp
// Author:  
// Date:    27-Apr-2021
// Purpose: Summarizes a table of numbers provided in CSV format.
//==============================================================================
#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
using namespace std;

struct Stats {
    double n, sum, min, max, mean;
};

/**
 * Opens and reads in a table of numbers in CSV format. Computes and prints
 * stats for every row and for the entire table. The result are displayed to the
 * console in this format, with every number given 3 significant digits, e.g.,
 * 8.001)
 * 
 * Row 1: n=<n> sum=<sum> [<min>, <mean>, <max>]
 * Row 2: n=<n> sum=<sum> [<min>, <mean>, <max>]
 * ...
 * TOTAL: n=<n> sum=<sum> [<min>, <mean>, <max>]
 * 
 * @param filename The name of the file to process.
 */
void SummarizeDataFile(string filename){
    Stats fullTableStats, rowStats;
    double curValue;
    char curSeperator;
    ifstream fin;
    int row = 1;

    fullTableStats.n = 0;
    fullTableStats.sum = 0;

    // TODO 1
    // Steps:
    // open fin
    // ensure it opened; if not, print an error and exit
    // while the input file stream is in a good state:
        // set rowStats: n = 0, sum = 0, mean = 0

        // do:
            // read the next number into curValue
            // read the next character into curSeparator: curSeperator = fin.get();

            // if the input file stream didn't fail:
                // if rowStats.n is 0:
                    // set rowStats: min = curValue, max = curValue
                // otherwise:
                    // update rowStats.min/max as necessary
                // increment rowStats.n
                // increase rowStats.sum by curValue
        // while curSeparator isn't '\n' (new line) and the input file stream hasn't failed

        // if rowStats.n > 0:
            // set rowStats.mean: sum/n
            // print rowStats (use `row` as the row number)

            // Update fullTableStats:
            // if fullTableStats.n is 0:
                // set fullTableStats.min and max to rowStats.min and max
            // otherwise:
                // update fullTableStats.min/max as necessary
            // increment fullTableStats.n
            // increase fullTableStats.sum by rowStats.sum

            // increment row

    // if fullTableStats.n > 0:
        // set fullTableStats.mean: sum/n
        // print fullTableStats

    // close the input file stream
}

/**
 * Interacts with the user to select a CSV file of numbers to summarize.
 * 
 * @return The exit status (0 is good).
 */
int main(){
    string filename;

    cout << "Please enter the path of the file to summarize: ";
    getline(cin, filename);

    SummarizeDataFile(filename);

    return 0;
}
